include stdio, stdlib;

class Pizza {

	String name;
	double radius;
	String color;
	double tomatoQuantity;

	new(=*);

	void describe() {
		printf("Pizza %s, of diameter %f, color %s, and tomato percentage %f\n", name, radius * 2, color, tomatoQuantity * 100);
	}

}

abstract class PizzaFactory {

	abstract Pizza makePizza();

}

class ChezGino extends PizzaFactory {

	implement makePizza {
		return new Pizza("Allegro Tomato", 0.25, "red", 0.6);
	}

}

class PizzaMaite extends PizzaFactory {

	implement makePizza {
		return new Pizza("Royale Grande", 0.50, "green", 0.4);
	}

}

int main() {
	
	PizzaFactory factories[] = {new ChezGino(), new PizzaMaite()};
	for(PizzaFactory factory: factories) {
		factory.makePizza().describe();	
	}

}
