include stdio, stdlib, stdbool;
include time, string;

use glut;

static boolean test;

class Color {
	double r;
	double g;
	double b;
	double a;

	new(=*);
}

class Window {

	String name;
	int width;
	int height;
	Color clearColor;

	new(=name, =width, =height);
	
	void show() {
		glutInitDisplayMode(GLUT_DEPTH | GLUT_RGBA);
		glutInitWindowPosition(0, 0);
		glutInitWindowSize(width, height); 
		glutCreateWindow(name);
		glutDisplayFunc(display);
		clearColor = new Color(1.0, 0.5, 0.2, 0.0);
	}

	void updateClearColor() {
		clearColor.r = clearColor.r + 0.05;
		if(clearColor.r > 1.0) {
			clearColor.r = 0.0;
		}
		glClearColor(clearColor.r, clearColor.g, clearColor.b, clearColor.a);
	}

	callback void display() {
		updateClearColor();
		glClear(GL_COLOR_BUFFER_BIT);
		glutSwapBuffers();
		if(test) {
			printf("In test mode, exiting gracefully =)\n");
			exit(0);
		}
	}

}

class Application {

        Window window;

        new(int *argc, char **argv) {
                glutInit(argc, argv);
                window = new Window("My super window", 1024, 768);
        }

        void run() {
                window.show();
                glutMainLoop();
        }

}

int main(int argc, char **argv) {

		if(argc >= 2 && strcmp(argv[1], "--test") == 0) {
			test = true;
		}
		
        Application app = new Application(&argc, argv);
        app.run();

}
