use gtk;
import Widget;

/**
 * A container is a widget that can contain other widgets
 */
abstract class Container extends Widget {

	/**
	 * Add a widget to this container
	 * @param widget the widget to add
	 */
	void add(Widget widget) {
		gtk_container_add(GTK_CONTAINER(this.getWidget()), widget.getWidget());
	}
	
	/**
	 * Remove a widget from this container
	 * @param widget the widget to remove
	 */
	void remove(Widget widget) {
		gtk_container_remove(GTK_CONTAINER(this.getWidget()), widget.getWidget());
	}
	
	/**
	 * Change the width of the border of this container
	 * @param width
	 */
	void setBorderWidth(int width) {
		gtk_container_set_border_width(GTK_CONTAINER(this.getWidget()), width);
	}

}

