include stdio, stdlib;
import io.Writer;

class FileWriter extends Writer {

	FILE* file;
	
	new(String fileName) {
		file = fopen(fileName, "w");
		if(!file) {
			printf("[io.FileWriter] File cannot be opened for writing: %s\n", fileName);
			exit(1);
		}
	}
	
	/**
	 * @param file A file to write to. Must be fopen()ed already. 
	 */
	new(=file) {
		if(!file) {
			printf("[io.FileWriter] Bad file passed to constructor.\n");
			exit(1);
		}
	}
	
	implement flush {
		fflush(file);
	}
	
	implement closeImpl {
		fclose(file);
	}
	
	void write(char c) {
		fputc(c, file);
	}
	
	void write(char[] cbuf, int off, int len) {
		// The size of a char is always 1
		fwrite(cbuf + off, 1, len, file);
	}

}
