include stdio;

/**
 * The writer interface provides a medium-indendant way to write characters
 * to a destination, e.g. a file, a string, a connection, etc.
 */
abstract class Writer {

	boolean closed = false;

	=closed isClosed();
	
	void close() {
		closeImpl();
		closed = true;
	}
	
	abstract void flush();
	abstract void closeImpl();
	abstract void write(char c);
	abstract void write(char[] cbuf, int off, int len);
	
	void write(String s) {
		write(s, 0, strlen(s));
	}

}
